uqmi: use built-in command for data-link verification
[openwrt/staging/chunkeey.git] / package / network / utils / uqmi / files / lib / netifd / proto / qmi.sh
index 7b58f6dd90ae7a043fbd09e0b8bf0d7d43cd99e4..c3da5ede26b14cae5e57d6f9b0f62edfc09421eb 100755 (executable)
@@ -27,7 +27,7 @@ proto_qmi_init_config() {
 
 proto_qmi_setup() {
        local interface="$1"
-
+       local dataformat connstat
        local device apn auth username password pincode delay modes pdptype profile dhcpv6 autoconnect plmn $PROTO_DEFAULT_OPTIONS
        local cid_4 pdh_4 cid_6 pdh_6
        local ip_6 ip_prefix_length gateway_6 dns1_6 dns2_6
@@ -65,11 +65,12 @@ proto_qmi_setup() {
        [ -n "$delay" ] && sleep "$delay"
 
        while uqmi -s -d "$device" --get-pin-status | grep '"UIM uninitialized"' > /dev/null; do
+               [ -e "$device" ] || return 1
                sleep 1;
        done
 
        [ -n "$pincode" ] && {
-               uqmi -s -d "$device" --verify-pin1 "$pincode" || uqmi -s -d "$device" --uim-verify-pin1 "$pincode" || {
+               uqmi -s -d "$device" --verify-pin1 "$pincode" > /dev/null || uqmi -s -d "$device" --uim-verify-pin1 "$pincode" > /dev/null || {
                        echo "Unable to verify PIN"
                        proto_notify_error "$interface" PIN_FAILED
                        proto_block_restart "$interface"
@@ -96,12 +97,30 @@ proto_qmi_setup() {
                }
        }
 
+       # Cleanup current state if any
+       uqmi -s -d "$device" --stop-network 0xffffffff --autoconnect
+
+       # Set IP format
        uqmi -s -d "$device" --set-data-format 802.3
        uqmi -s -d "$device" --wda-set-data-format 802.3
+       dataformat="$(uqmi -s -d "$device" --wda-get-data-format)"
+
+       if [ "$dataformat" = '"raw-ip"' ]; then
+
+               [ -f /sys/class/net/$ifname/qmi/raw_ip ] || {
+                       echo "Device only supports raw-ip mode but is missing this required driver attribute: /sys/class/net/$ifname/qmi/raw_ip"
+                       return 1
+               }
+
+               echo "Device does not support 802.3 mode. Informing driver of raw-ip only for $ifname .."
+               echo "Y" > /sys/class/net/$ifname/qmi/raw_ip
+       fi
+
        uqmi -s -d "$device" --sync
 
        echo "Waiting for network registration"
        while uqmi -s -d "$device" --get-serving-system | grep '"searching"' > /dev/null; do
+               [ -e "$device" ] || return 1
                sleep 5;
        done
 
@@ -109,7 +128,7 @@ proto_qmi_setup() {
 
        echo "Starting network $interface"
 
-       pdptype=`echo "$pdptype" | awk '{print tolower($0)}'`
+       pdptype=$(echo "$pdptype" | awk '{print tolower($0)}')
        [ "$pdptype" = "ip" -o "$pdptype" = "ipv6" -o "$pdptype" = "ipv4v6" ] || pdptype="ip"
 
        if [ "$pdptype" = "ip" ]; then
@@ -120,7 +139,7 @@ proto_qmi_setup() {
        fi
 
        [ "$pdptype" = "ip" -o "$pdptype" = "ipv4v6" ] && {
-               cid_4=`uqmi -s -d "$device" --get-client-id wds`
+               cid_4=$(uqmi -s -d "$device" --get-client-id wds)
                [ $? -ne 0 ] && {
                        echo "Unable to obtain client ID"
                        proto_notify_error "$interface" NO_CID
@@ -129,29 +148,35 @@ proto_qmi_setup() {
 
                uqmi -s -d "$device" --set-client-id wds,"$cid_4" --set-ip-family ipv4 > /dev/null
 
-               # try to clear previous autoconnect state
-               uqmi -s -d "$device" --set-client-id wds,"$cid_4" \
-                       --stop-network 0xffffffff \
-                       --autoconnect > /dev/null
-
-               pdh_4=`uqmi -s -d "$device" --set-client-id wds,"$cid_4" \
+               pdh_4=$(uqmi -s -d "$device" --set-client-id wds,"$cid_4" \
                        --start-network \
                        ${apn:+--apn $apn} \
                        ${profile:+--profile $profile} \
                        ${auth:+--auth-type $auth} \
                        ${username:+--username $username} \
                        ${password:+--password $password} \
-                       ${autoconnect:+--autoconnect}`
-               [ $? -ne 0 ] && {
+                       ${autoconnect:+--autoconnect})
+
+        # pdh_4 is a numeric value on success
+               if ! [ "$pdh_4" -eq "$pdh_4" ] 2> /dev/null; then
                        echo "Unable to connect IPv4"
                        uqmi -s -d "$device" --set-client-id wds,"$cid_4" --release-client-id wds
                        proto_notify_error "$interface" CALL_FAILED
                        return 1
-               }
+               fi
+
+        # Check data connection state
+               connstat=$(uqmi -s -d "$device" --get-data-status)
+                [ "$connstat" == '"connected"' ] || {
+                        echo "No data link!"
+                        uqmi -s -d "$device" --set-client-id wds,"$cid_4" --release-client-id wds
+                        proto_notify_error "$interface" CALL_FAILED
+                        return 1
+                }
        }
 
        [ "$pdptype" = "ipv6" -o "$pdptype" = "ipv4v6" ] && {
-               cid_6=`uqmi -s -d "$device" --get-client-id wds`
+               cid_6=$(uqmi -s -d "$device" --get-client-id wds)
                [ $? -ne 0 ] && {
                        echo "Unable to obtain client ID"
                        proto_notify_error "$interface" NO_CID
@@ -160,25 +185,31 @@ proto_qmi_setup() {
 
                uqmi -s -d "$device" --set-client-id wds,"$cid_6" --set-ip-family ipv6 > /dev/null
 
-               # try to clear previous autoconnect state
-               uqmi -s -d "$device" --set-client-id wds,"$cid_6" \
-                       --stop-network 0xffffffff \
-                       --autoconnect > /dev/null
-
-               pdh_6=`uqmi -s -d "$device" --set-client-id wds,"$cid_6" \
+               pdh_6=$(uqmi -s -d "$device" --set-client-id wds,"$cid_6" \
                        --start-network \
                        ${apn:+--apn $apn} \
                        ${profile:+--profile $profile} \
                        ${auth:+--auth-type $auth} \
                        ${username:+--username $username} \
                        ${password:+--password $password} \
-                       ${autoconnect:+--autoconnect}`
-               [ $? -ne 0 ] && {
+                       ${autoconnect:+--autoconnect})
+
+        # pdh_6 is a numeric value on success
+               if ! [ "$pdh_6" -eq "$pdh_6" ] 2> /dev/null; then
                        echo "Unable to connect IPv6"
                        uqmi -s -d "$device" --set-client-id wds,"$cid_6" --release-client-id wds
                        proto_notify_error "$interface" CALL_FAILED
                        return 1
-               }
+               fi
+
+        # Check data connection state
+               connstat=$(uqmi -s -d "$device" --get-data-status)
+                [ "$connstat" == '"connected"' ] || {
+                        echo "No data link!"
+                        uqmi -s -d "$device" --set-client-id wds,"$cid_6" --release-client-id wds
+                        proto_notify_error "$interface" CALL_FAILED
+                        return 1
+                }
        }
 
        echo "Setting up $ifname"